SystemOrganization addCategory: #'Stack-Exercise'!

Object subclass: #EmptyStackNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!EmptyStackNode methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/7/2013 18:49'!
element
	^self error: OOStack stackEmptyErrorDescription! !

!EmptyStackNode methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/6/2013 21:28'!
isEmpty
	^ true! !

!EmptyStackNode methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/6/2013 21:21'!
previous
	^ Error! !

!EmptyStackNode methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/6/2013 21:32'!
size 
	^ 0! !

Object subclass: #OOStack
	instanceVariableNames: 'top elements size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!OOStack class methodsFor: 'error descriptions' stamp: 'HernanWilkinson 5/7/2012 11:51'!
stackEmptyErrorDescription
	
	^ 'Stack is empty'! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/6/2013 21:27'!
initialize
	top:= EmptyStackNode new.
	^self! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/6/2013 21:29'!
isEmpty
	^top isEmpty! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/6/2013 22:00'!
pop
	|result|
	
	result:= top element.
	top:= top previous.
	
	^result
	! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/6/2013 21:54'!
push: anObject  
	|nodo|
	nodo:= StackNode new.
	top := nodo initialize:  top withElement:  anObject.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/6/2013 22:02'!
size 
	^ top size! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/6/2013 22:01'!
top
	^ top element! !

Object subclass: #StackNode
	instanceVariableNames: 'element previousNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

StackNode class
	instanceVariableNames: 'element previous'!

StackNode class
	instanceVariableNames: 'element previous'!

!StackNode methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/6/2013 21:26'!
element 
	^element! !

!StackNode methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/6/2013 21:59'!
initialize: aStackNode withElement: anElement 
	element := anElement.
	previousNode := aStackNode.
	^self! !

!StackNode methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/6/2013 21:28'!
isEmpty
	^false! !

!StackNode methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/6/2013 21:00'!
previous
	^previousNode! !

!StackNode methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/6/2013 21:34'!
size
	^(previousNode size) + 1! !

TestCase subclass: #OOStackTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:30'!
test01StackShouldBeEmptyWhenCreated

	| stack |
	
	stack := OOStack new.
	
	self assert: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'EmilianoMenendezEzequielNicols 5/6/2013 21:39'!
test02PushAddElementsToTheStack

	| stack |
	
	stack := OOStack new.
	stack push: 'Something'.
	
	self deny: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:31'!
test03PopRemovesElementsFromTheStack

	| stack |
	
	stack := OOStack new.
	stack push: 'Something'.
	stack pop.
	
	self assert: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/8/2012 08:20'!
test04PopReturnsLastPushedObject

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	stack push: pushedObject.
	
	self assert: stack pop = pushedObject! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:33'!
test05StackBehavesLIFO

	| stack firstPushedObject secondPushedObject |
	
	stack := OOStack new.
	firstPushedObject := 'First'.
	secondPushedObject := 'Second'.
	
	stack push: firstPushedObject.
	stack push: secondPushedObject.
	
	self assert: stack pop = secondPushedObject.
	self assert: stack pop = firstPushedObject.
	self assert: stack isEmpty 
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:35'!
test06TopReturnsLastPushedObject

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	
	stack push: pushedObject.
	
	self assert: stack top = pushedObject.
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:36'!
test07TopDoesNotRemoveObjectFromStack

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	
	stack push: pushedObject.
	
	self assert: stack size = 1.
	stack top.
	self assert: stack size = 1.
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:38'!
test08CanNotPopWhenThereAreNoObjectsInTheStack

	| stack  |
	
	stack := OOStack new.
	self
		should: [ stack pop ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/16/2012 16:53'!
test09CanNotPopWhenThereAreNoObjectsInTheStackAndTheStackHadObjects

	| stack  |
	
	stack := OOStack new.
	stack push: 'Something'.
	stack pop.
	
	self
		should: [ stack pop ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/16/2012 16:53'!
test10CanNotTopWhenThereAreNoObjectsInTheStack

	| stack  |
	
	stack := OOStack new.
	self
		should: [ stack top ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !
